// SelectFolder.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "isdll.h"
#include "SelectFolder.h"
#include "dirdialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CSelectFolder 


CSelectFolder::CSelectFolder(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectFolder::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectFolder)
	m_strFolder = _T("");
	m_Desc = _T("");
	//}}AFX_DATA_INIT
}


void CSelectFolder::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectFolder)
	DDX_Text(pDX, IDC_EDIT1, m_strFolder);
	DDX_Text(pDX, IDS_DESCRIPTION, m_Desc);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectFolder, CDialog)
	//{{AFX_MSG_MAP(CSelectFolder)
	ON_BN_CLICKED(IDC_BACK, OnBack)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_WM_PAINT()
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_EN_UPDATE(IDC_EDIT1, OnChangeEdit1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CSelectFolder 

void CSelectFolder::OnBack() 
{
	UpdateData(TRUE);
	EndDialog(IDC_BACK);
}

void CSelectFolder::OnBrowse() 
{
	CDirDialog dlg;
	UpdateData(TRUE);
	dlg.m_strSelDir = m_strFolder;
	dlg.m_strTitle = "Bitte whlen Sie einen Ordner fr die Installation aus.";
	if (dlg.DoBrowse())
	{
		m_strFolder=dlg.m_strPath;
		UpdateData(FALSE);
	}
	OnChangeEdit1();
}

void CSelectFolder::OnNext() 
{
	UpdateData(TRUE);
	EndDialog(IDC_NEXT);
}

void CSelectFolder::OnCancel() 
{
	// TODO: Zustzlichen Bereinigungscode hier einfgen
	
	CDialog::OnCancel();
}

BOOL CSelectFolder::OnInitDialog() 
{
	CWnd* pWnd;
	SetWindowText(m_strTitle);
	CDialog::OnInitDialog();
	if ((pWnd = GetDlgItem(IDC_BMP)) != NULL)
	{
		pWnd->GetWindowRect(m_rcBmp);
		ScreenToClient(m_rcBmp);
	}

	OnChangeEdit1();
	return TRUE;  // return TRUE unless you set the focus to a control
                  // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

BOOL CSelectFolder::GetBitmapAndPalette(UINT nIDResource, CBitmap &bitmap, CPalette &pal)
{
	LPCTSTR lpszResourceName = (LPCTSTR)nIDResource;

	HBITMAP hBmp = (HBITMAP)::LoadImage( AfxGetInstanceHandle(), 
			lpszResourceName, IMAGE_BITMAP, 0,0, LR_CREATEDIBSECTION );

	if( hBmp == NULL ) 
		return FALSE;

	bitmap.Attach( hBmp );

	// Create a logical palette for the bitmap
	DIBSECTION ds;
	BITMAPINFOHEADER &bmInfo = ds.dsBmih;
	bitmap.GetObject( sizeof(ds), &ds );

	int nColors = bmInfo.biClrUsed ? bmInfo.biClrUsed : 1 << bmInfo.biBitCount;

	// Create a halftone palette if colors > 256. 
	CClientDC dc(NULL);			// Desktop DC
	if( nColors > 256 )
		pal.CreateHalftonePalette( &dc );
	else
	{
		// Create the palette

		RGBQUAD *pRGB = new RGBQUAD[nColors];
		CDC memDC;
		memDC.CreateCompatibleDC(&dc);

		memDC.SelectObject( &bitmap );
		::GetDIBColorTable( memDC, 0, nColors, pRGB );

		UINT nSize = sizeof(LOGPALETTE) + (sizeof(PALETTEENTRY) * nColors);
		LOGPALETTE *pLP = (LOGPALETTE *) new BYTE[nSize];

		pLP->palVersion = 0x300;
		pLP->palNumEntries = nColors;

		for( int i=0; i < nColors; i++)
		{
			pLP->palPalEntry[i].peRed = pRGB[i].rgbRed;
			pLP->palPalEntry[i].peGreen = pRGB[i].rgbGreen;
			pLP->palPalEntry[i].peBlue = pRGB[i].rgbBlue;
			pLP->palPalEntry[i].peFlags = 0;
		}

		pal.CreatePalette( pLP );

		delete[] pLP;
		delete[] pRGB;
	}

	return TRUE;
}

void CSelectFolder::OnPaint() 
{

	CPaintDC dc(this);

	// Create a memory DC compatible with the paint DC
	CDC memDC;
	memDC.CreateCompatibleDC( &dc );

	CBitmap bitmap;
	CPalette palette;

	GetBitmapAndPalette( IDB_SETUP, bitmap, palette );
	memDC.SelectObject( &bitmap );

	// Select and realize the palette
	if( dc.GetDeviceCaps(RASTERCAPS) & RC_PALETTE && palette.m_hObject != NULL )
	{
		dc.SelectPalette( &palette, FALSE );
		dc.RealizePalette();
	}
	dc.BitBlt(m_rcBmp.left,m_rcBmp.top,m_rcBmp.Width(),m_rcBmp.Height(), &memDC, 0, 0,SRCCOPY);
}

void CSelectFolder::OnChangeEdit1() 
{
	UpdateData(TRUE);
	CWnd* pWnd = GetDlgItem(IDC_NEXT);
	if (pWnd != NULL)
		pWnd->EnableWindow(!(m_strFolder.IsEmpty()));

}
